! subroutines to read pre-stored look-up-tables
subroutine getres1d(array,szas,tvalss,ts,ress)
implicit none
integer, intent(in) :: szas
real, intent(in) :: array(szas), tvalss(szas), ts
real, intent(out) :: ress
integer :: lis, uis
real :: ms

lis = maxloc(tvalss, dim=1, mask = ts.ge.tvalss)
uis = minloc(tvalss, dim=1, mask = ts.le.tvalss)
if (lis.eq.uis) then
  ress = array(lis)
  return
end if

ms=(array(uis)-array(lis))/(tvalss(uis)-tvalss(lis))
ress = ms*(ts-tvalss(lis))+array(lis)
end subroutine

subroutine getres2d(array,szas,szbs,tvalss,sktorlr,ts,storg0,ress)
implicit none
integer, intent(in) :: szas, szbs
real, intent(in) :: array(szas,szbs), tvalss(szas), sktorlr(szbs), ts, storg0
real, intent(out) :: ress
integer :: li1s, ui1s, li2s, ui2s
real :: ms, ress1, ress2

li1s = maxloc(tvalss, dim=1, mask = ts.ge.tvalss)
ui1s = minloc(tvalss, dim=1, mask = ts.le.tvalss)

li2s = maxloc(sktorlr, dim=1, mask = storg0.ge.sktorlr)
ui2s = minloc(sktorlr, dim=1, mask = storg0.le.sktorlr)

if (li1s.eq.ui1s .and. li2s.eq.ui2s) then
  ress = array(li1s,li2s)
  return
end if

if (li1s.eq.ui1s) then
  ms=(array(ui1s,ui2s)-array(ui1s,li2s))/(sktorlr(ui2s)-sktorlr(li2s))
  ress=ms*(storg0-sktorlr(li2s))+array(ui1s,li2s)
  return
end if

ms=(array(ui1s,li2s)-array(li1s,li2s))/(tvalss(ui1s)-tvalss(li1s))
ress1 = ms*(ts-tvalss(li1s))+array(li1s,li2s)

ms=(array(ui1s,ui2s)-array(li1s,ui2s))/(tvalss(ui1s)-tvalss(li1s))
ress2 = ms*(ts-tvalss(li1s))+array(li1s,ui2s)

if (ress1.eq.ress2) then
  ress = ress1
  return
end if

ms=(ress2-ress1)/(sktorlr(ui2s)-sktorlr(li2s))
ress=ms*(storg0-sktorlr(li2s))+ress1
end subroutine

subroutine getres3d(array,szas,szbs,szcs,tvalss,lrs,skts,ts,g0s,sts,ress)
implicit none
integer, intent(in) :: szas, szbs, szcs
real, intent(in) :: array(szas,szbs,szcs), tvalss(szas), lrs(szbs), skts(szcs), ts, g0s, sts
real, intent(out) :: ress
integer :: li1s, ui1s, li2s, ui2s, li3s, ui3s
real :: ms, ress1, ress2, ressu, ressl

li1s = maxloc(tvalss, dim=1, mask = ts.ge.tvalss)
ui1s = minloc(tvalss, dim=1, mask = ts.le.tvalss)

li2s = maxloc(lrs, dim=1, mask = g0s.ge.lrs)
ui2s = minloc(lrs, dim=1, mask = g0s.le.lrs)

li3s = maxloc(skts, dim=1, mask = sts.ge.skts)
ui3s = minloc(skts, dim=1, mask = sts.le.skts)

if (li1s.eq.ui1s .and. li2s.eq.ui2s .and. li3s.eq.ui3s) then
  ress = array(li1s,li2s,li3s)
  return
end if

if (li1s.eq.ui1s .and. li2s.ne.ui2s) then
  ms=(array(ui1s,ui2s,li3s)-array(ui1s,li2s,li3s))/(lrs(ui2s)-lrs(li2s))
  ress1 = ms*(g0s-lrs(li2s))+array(ui1s,li2s,li3s)

  ms=(array(ui1s,ui2s,ui3s)-array(ui1s,li2s,ui3s))/(lrs(ui2s)-lrs(li2s))
  ress2 = ms*(g0s-lrs(li2s))+array(ui1s,li2s,ui3s)

  if (ress1.eq.ress2) then
    ress = ress1
    return
  end if

  ms=(ress2-ress1)/(skts(ui3s)-skts(li3s))
  ress=ms*(sts-skts(li3s))+ress1
  return
end if

if (li2s.eq.ui2s .and. li3s.ne.ui3s) then
  ms=(array(li1s,ui2s,ui3s)-array(li1s,ui2s,li3s))/(skts(ui3s)-skts(li3s))
  ress1 = ms*(sts-skts(li3s))+array(li1s,ui2s,li3s)

  ms=(array(ui1s,ui2s,ui3s)-array(ui1s,ui2s,li3s))/(skts(ui3s)-skts(li3s))
  ress2 = ms*(sts-skts(li3s))+array(ui1s,ui2s,li3s)

  if (ress1.eq.ress2) then
    ress = ress1
    return
  end if

  ms=(ress2-ress1)/(tvalss(ui1s)-tvalss(li1s))
  ress=ms*(ts-tvalss(li1s))+ress1
  return
end if

if (li1s.ne.ui1s .and. li3s.eq.ui3s) then
  ms=(array(ui1s,li2s,ui3s)-array(li1s,li2s,ui3s))/(tvalss(ui1s)-tvalss(li1s))
  ress1 = ms*(ts-tvalss(li1s))+array(li1s,li2s,ui3s)

  ms=(array(ui1s,ui2s,ui3s)-array(li1s,ui2s,ui3s))/(tvalss(ui1s)-tvalss(li1s))
  ress2 = ms*(ts-tvalss(li1s))+array(li1s,ui2s,ui3s)

  if (ress1.eq.ress2) then
    ress = ress1
    return
  end if

  ms=(ress2-ress1)/(lrs(ui2s)-lrs(li2s))
  ress=ms*(g0s-lrs(li2s))+ress1
  return
end if

ms=(array(ui1s,ui2s,li3s)-array(ui1s,li2s,li3s))/(lrs(ui2s)-lrs(li2s))
ress1 = ms*(g0s-lrs(li2s))+array(ui1s,li2s,li3s)

ms=(array(ui1s,ui2s,ui3s)-array(ui1s,li2s,ui3s))/(lrs(ui2s)-lrs(li2s))
ress2 = ms*(g0s-lrs(li2s))+array(ui1s,li2s,ui3s)

ms=(ress2-ress1)/(skts(ui3s)-skts(li3s))
ressu=ms*(sts-skts(li3s))+ress1

ms=(array(li1s,ui2s,li3s)-array(li1s,li2s,li3s))/(lrs(ui2s)-lrs(li2s))
ress1 = ms*(g0s-lrs(li2s))+array(li1s,li2s,li3s)

ms=(array(li1s,ui2s,ui3s)-array(li1s,li2s,ui3s))/(lrs(ui2s)-lrs(li2s))
ress2 = ms*(g0s-lrs(li2s))+array(li1s,li2s,ui3s)

ms=(ress2-ress1)/(skts(ui3s)-skts(li3s))
ressl=ms*(sts-skts(li3s))+ress1

ms=(ressu-ressl)/(tvalss(ui1s)-tvalss(li1s))
ress=ms*(ts-tvalss(li1s))+ressl
end subroutine
